﻿using Infragistics.Win;
using Infragistics.Win.UltraWinMaskedEdit;
using Infragistics.Win.UltraWinToolbars;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ToolbarsManagerPopupDrawFilterTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();            
            ultraToolbarsManager1.CreationFilter = new ToolbarsManagerCreationFilter();

            this.Load += Form1_Load;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            UltraToolbar toolbar = ultraToolbarsManager1.Toolbars[0];
            PopupMenuTool menu = toolbar.Tools[0] as PopupMenuTool;

            foreach (var tool in menu.Tools)
            {
                tool.SharedProps.DescriptionOnMenu = "Description on Menu!";
                tool.SharedProps.AppearancesLarge.AppearanceOnMenu.BackColor = Color.LightBlue;
                tool.SharedProps.AppearancesLarge.AppearanceOnMenu.BackColor2 = Color.LightBlue;
                tool.SharedProps.AppearancesSmall.AppearanceOnMenu.BackColor = Color.LightBlue;
                tool.SharedProps.AppearancesSmall.AppearanceOnMenu.BackColor2 = Color.LightBlue;
            }
        }
    }

    public class ToolbarsManagerCreationFilter : IUIElementCreationFilter
    {
        public void AfterCreateChildElements(UIElement parent)
        {
            //if (parent is PopupMenuItemDescriptionUIElement)
            if (parent is PopupMenuItemUIElement)
            {                
                    var rectInsideBorders = parent.RectInsideBorders;

                    MyButtonUIElement buttonElement = new MyButtonUIElement(parent);

                    buttonElement.Rect = new Rectangle(
                        rectInsideBorders.Right - 16,
                        rectInsideBorders.Top,
                        16,
                        16    
                        );
                    parent.ChildElements.Add(buttonElement);
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}
