﻿using Infragistics.Win;
using Infragistics.Win.UltraWinToolbars;
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ToolbarsManagerPopupDrawFilterTest
{
    public class MyButtonUIElement : ButtonUIElementBase
    {
        private ImageUIElement imageElement;
        public MyButtonUIElement(UIElement parent) : base(parent)
        {
        }

        public override UIElementButtonStyle ButtonStyle
        {
            get
            {
                return UIElementButtonStyle.Borderless;
            }
        }

        protected override void InitAppearance(ref AppearanceData appearanceData, ref AppearancePropFlags requestedProps)
        {
            if (AppearancePropFlags.ThemedElementAlpha == (requestedProps & AppearancePropFlags.ThemedElementAlpha))
            {
                appearanceData.ThemedElementAlpha = Alpha.Transparent;
                requestedProps &= ~AppearancePropFlags.ThemedElementAlpha;
            }

            if (AppearancePropFlags.BackColor == (requestedProps & AppearancePropFlags.BackColor))
            {
                appearanceData.BackColor = Color.Transparent;
                requestedProps &= ~AppearancePropFlags.BackColor;
            }

//            base.InitAppearance(ref appearanceData, ref requestedProps);
        }

        protected override bool ButtonClick()
        {
            var tool = this.GetContext(typeof(ToolBase)) as ToolBase;
            MessageBox.Show(tool.Key);
            return base.ButtonClick();
        }

        protected override void PositionChildElements()
        {
            if (null == this.imageElement)
            {
                var image = Bitmap.FromFile("../../Images/16x16-icon-45590.png");
                this.imageElement = new ImageUIElement(this, image);
                this.imageElement.Scaled = true;
                this.ChildElements.Add(this.imageElement);
            }
            this.imageElement.Rect = this.RectInsideBorders;
        }

        protected override void OnDispose()
        {
            if (null != this.imageElement)
                this.imageElement.Dispose();
            
            base.OnDispose();
        }
    }
}
